<?php

namespace App\Lib\Unifaun\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PriceResultList StructType
 * @subpackage Structs
 */
class PriceResultList extends AbstractStructBase
{
    /**
     * The priceResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App\Lib\Unifaun\StructType\PriceResult[]
     */
    public $priceResult;
    /**
     * Constructor method for PriceResultList
     * @uses PriceResultList::setPriceResult()
     * @param \App\Lib\Unifaun\StructType\PriceResult[] $priceResult
     */
    public function __construct(array $priceResult = array())
    {
        $this
            ->setPriceResult($priceResult);
    }
    /**
     * Get priceResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App\Lib\Unifaun\StructType\PriceResult[]|null
     */
    public function getPriceResult()
    {
        return isset($this->priceResult) ? $this->priceResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPriceResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPriceResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePriceResultForArrayConstraintsFromSetPriceResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $priceResultListPriceResultItem) {
            // validation for constraint: itemType
            if (!$priceResultListPriceResultItem instanceof \App\Lib\Unifaun\StructType\PriceResult) {
                $invalidValues[] = is_object($priceResultListPriceResultItem) ? get_class($priceResultListPriceResultItem) : sprintf('%s(%s)', gettype($priceResultListPriceResultItem), var_export($priceResultListPriceResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The priceResult property can only contain items of type \App\Lib\Unifaun\StructType\PriceResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set priceResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\PriceResult[] $priceResult
     * @return \App\Lib\Unifaun\StructType\PriceResultList
     */
    public function setPriceResult(array $priceResult = array())
    {
        // validation for constraint: array
        if ('' !== ($priceResultArrayErrorMessage = self::validatePriceResultForArrayConstraintsFromSetPriceResult($priceResult))) {
            throw new \InvalidArgumentException($priceResultArrayErrorMessage, __LINE__);
        }
        if (is_null($priceResult) || (is_array($priceResult) && empty($priceResult))) {
            unset($this->priceResult);
        } else {
            $this->priceResult = $priceResult;
        }
        return $this;
    }
    /**
     * Add item to priceResult value
     * @throws \InvalidArgumentException
     * @param \App\Lib\Unifaun\StructType\PriceResult $item
     * @return \App\Lib\Unifaun\StructType\PriceResultList
     */
    public function addToPriceResult(\App\Lib\Unifaun\StructType\PriceResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Lib\Unifaun\StructType\PriceResult) {
            throw new \InvalidArgumentException(sprintf('The priceResult property can only contain items of type \App\Lib\Unifaun\StructType\PriceResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->priceResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Lib\Unifaun\StructType\PriceResultList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
